import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    private int delay = 0;
    private int delay2 = 0;
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    

    public Player()
    {
        setImage();
    }
    
    public void act()
    {
        setImage();
        chomp();
        movement();
        shoot();
    }
    
    public void setImage()  //sets the image to size.
    {
        GreenfootImage image = getImage();
        image.scale(55,29);
        setImage(image);
    }
    
    public void movement() // sets how the player is moved back and forth and the rotation method (more below on rotation method).
    {
        int angle = getRotation(); 
        if (Greenfoot.isKeyDown("w"))
        {
            move(4);
        }
        if (Greenfoot.isKeyDown("s"))
        {
            move(-4);
        }
        
        setRotation(angle);
        if(Greenfoot.mouseMoved(null)) // detects if mouse has moved, then turns the player towars the x and y coord of the mouse pointer.
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            turnTowards(mouse.getX(), mouse.getY());
        }
    }
    public void shoot() // checks if the delay is 0 and if it isnt it spawns a new bullet on the player and is shot out at the rotation that the player is facing, then the delay is set to 15.
    {
        if (delay > 0)
        {
            delay = delay-1;
        }
        else
        {
            if (Greenfoot.isKeyDown("space"))
            {
                Bullet b = new Bullet();
                getWorld().addObject(b, getX(), getY());
                b.setRotation(getRotation());
                delay = 5;
            }
        }
    }
    
    public void chompSound() // plays a hit noise when zombie hits player.
    {
        GreenfootSound hit = new GreenfootSound("hitSound.wav");
        hit.setVolume(85);
        hit.play();
    }
    
    public void chomp() //when the zombie or zombie boss touches player, they lose 1 or 3 lives depending on the zombie type that has intersected.
    {
        if (delay2 > 0)
        {
            delay2 = delay2-1;
        }
        else 
        {
            Actor Zombie = getOneIntersectingObject(Zombie.class);
            Actor ZombieBoss = getOneIntersectingObject(ZombieBoss.class);
            if(Zombie != null)
            {
                waveZWorld waveWorld = (waveZWorld)getWorld();
                waveWorld.loseLife(this);
                chompSound();
                delay2 = 25;
            }
            if(ZombieBoss != null)
            {
                waveZWorld waveWorld = (waveZWorld)getWorld();
                waveWorld.loseLifeBoss(this);
                chompSound();
                delay2 = 50;
            }
        }
    }
    
    public void heal() // when the player touches medkit add one health.
    {
        Actor Medkit = getOneIntersectingObject(Medkit.class);
        if(Medkit != null)
            {
                waveZWorld waveWorld = (waveZWorld)getWorld();
                waveWorld.removeObject(Medkit);
                Greenfoot.playSound("medSound.wav");
                waveWorld.GainLife();
            }
    }
}
